## ros-crystal-rcl-action 0.6.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcl_action)

find_package(ament_cmake_ros REQUIRED)

find_package(rosidl_generator_c REQUIRED)
find_package(action_msgs REQUIRED)
find_package(rcl REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

include_directories(
  include
  ${action_msgs_INCLUDE_DIRS}
  ${rcl_INCLUDE_DIRS}
)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

add_executable(test_compile_headers
  src/test_compile_headers.c
)

set(rcl_action_sources
  src/${PROJECT_NAME}/action_client.c
  src/${PROJECT_NAME}/action_server.c
  src/${PROJECT_NAME}/goal_handle.c
  src/${PROJECT_NAME}/goal_state_machine.c
  src/${PROJECT_NAME}/names.c
  src/${PROJECT_NAME}/types.c
)

set_source_files_properties(
  ${rcl_action_sources}
  PROPERTIES language "C"
)

add_library(${PROJECT_NAME}
  ${rcl_action_sources}
)

ament_target_dependencies(${PROJECT_NAME}
  "action_msgs"
  "rcl"
  "rcutils"
  "rmw"
  "rosidl_generator_c"
)
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "RCL_ACTION_BUILDING_DLL")

install(
  DIRECTORY include/
  DESTINATION include
)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(osrf_testing_tools_cpp REQUIRED)
  find_package(test_msgs REQUIRED)
  ament_lint_auto_find_test_dependencies()
  ament_find_gtest()
  # Gtests
  ament_add_gtest(test_action_client
    test/rcl_action/test_action_client.cpp
  )
  if(TARGET test_action_client)
    target_include_directories(test_action_client PUBLIC
      include
      ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    )
    target_link_libraries(test_action_client
      ${PROJECT_NAME}
    )
    ament_target_dependencies(test_action_client "rcl" "test_msgs")
  endif()

  # get the rmw implementations ahead of time
  find_package(rmw_implementation_cmake REQUIRED)
  get_available_rmw_implementations(rmw_implementations)
  foreach(rmw_implementation ${rmw_implementations})
    find_package("${rmw_implementation}" REQUIRED)
  endforeach()

  function(custom_test_c target)
    ament_add_gtest(
      "${target}${target_suffix}" ${ARGN}
      TIMEOUT 60
      APPEND_LIBRARY_DIRS "${append_library_dirs}"
      ENV
      RCL_ASSERT_RMW_ID_MATCHES=${rmw_implementation}
      RMW_IMPLEMENTATION=${rmw_implementation}
      ROS_SECURITY_ROOT_DIRECTORY="${VALID_ROS_SECURITY_ROOT_DIRECTORY}"
      PATH="${TEST_PATH}"
    )
    if(TARGET ${target}${target_suffix})
      target_compile_definitions(${target}${target_suffix}
        PUBLIC "RMW_IMPLEMENTATION=${rmw_implementation}")
      target_include_directories(${target}${target_suffix} PUBLIC
        include
        ${rcl_INCLUDE_DIRS}
      )
      target_link_libraries(${target}${target_suffix}
        ${PROJECT_NAME}
      )
      ament_target_dependencies(${target}${target_suffix}
        "test_msgs")
    endif()
  endfunction()

  macro(targets)
    set(ENV_PATH "$ENV{PATH}")
    file(TO_CMAKE_PATH "${ENV_PATH}" ENV_PATH)
    set(TEST_PATH "${ENV_PATH}")
    if(rmw_implementation STREQUAL "rmw_connext_cpp")
      if(UNIX AND NOT APPLE)
        set(RTI_BIN_PATH "$ENV{RTI_OPENSSL_BIN}")
        file(TO_CMAKE_PATH "${RTI_BIN_PATH}" RTI_BIN_PATH)
        set(TEST_PATH "${RTI_BIN_PATH};${ENV_PATH}")
        if(NOT WIN32)
          string(REPLACE ";" ":" TEST_PATH "${TEST_PATH}")
        endif()
      endif()
    endif()
    custom_test_c(test_action_communication
      "test/rcl_action/test_action_communication.cpp")
    custom_test_c(test_action_interaction
      "test/rcl_action/test_action_interaction.cpp")
  endmacro()

  call_for_each_rmw_implementation(targets)

  ament_add_gtest(test_action_server
    test/rcl_action/test_action_server.cpp
  )
  if(TARGET test_action_server)
    target_include_directories(test_action_server PUBLIC
      include
      ${rcl_INCLUDE_DIRS}
    )
    target_link_libraries(test_action_server
      ${PROJECT_NAME}
    )
    ament_target_dependencies(test_action_server "test_msgs")
  endif()
  ament_add_gtest(test_goal_handle
    test/rcl_action/test_goal_handle.cpp
  )
  if(TARGET test_goal_handle)
    target_include_directories(test_goal_handle PUBLIC
      include
      ${rcl_INCLUDE_DIRS}
    )
    target_link_libraries(test_goal_handle
      ${PROJECT_NAME}
    )
  endif()
  ament_add_gtest(test_goal_state_machine
    test/rcl_action/test_goal_state_machine.cpp
  )
  if(TARGET test_goal_state_machine)
    target_include_directories(test_goal_state_machine PUBLIC
      ${rcl_INCLUDE_DIRS}
    )
    target_link_libraries(test_goal_state_machine
      ${PROJECT_NAME}
    )
  endif()
  ament_add_gtest(test_types
    test/rcl_action/test_types.cpp
  )
  if(TARGET test_types)
    target_include_directories(test_types PUBLIC
      include
      ${rcl_INCLUDE_DIRS}
    )
    target_link_libraries(test_types
      ${PROJECT_NAME}
    )
  endif()
  ament_add_gtest(test_names
    test/rcl_action/test_names.cpp
  )
  if(TARGET test_names)
    target_include_directories(test_names PUBLIC
      ${rcl_INCLUDE_DIRS}
    )
    target_link_libraries(test_names
      ${PROJECT_NAME}
    )
  endif()
endif()

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(ament_cmake)
ament_export_dependencies(rcl)
ament_export_dependencies(rcutils)
ament_export_dependencies(rmw)
ament_export_dependencies(action_msgs)
ament_export_dependencies(rosidl_generator_c)
ament_package()

=== debian/changelog ===
ros-crystal-rcl-action (0.6.6-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Sat, 17 Aug 2019 07:00:00 -0000

ros-crystal-rcl-action (0.6.5-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Fri, 08 Feb 2019 08:00:00 -0000

ros-crystal-rcl-action (0.6.4-1bionic) bionic; urgency=high

  * Added parentheses around use of zerouuid macro (#371 <https://github.com/ros2/rcl/issues/371>)
  * Fixed logic that moves goal handles when one expires (#360 <https://github.com/ros2/rcl/issues/360>)
  * Updated to avoid timer period being set to 0 (#359 <https://github.com/ros2/rcl/issues/359>)
  * Contributors: Jacob Perron, Shane Loretz

 -- Jacob Perron <jacob@openrobotics.org>  Fri, 11 Jan 2019 08:00:00 -0000

ros-crystal-rcl-action (0.6.3-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-crystal-rcl-action (0.6.2-1bionic) bionic; urgency=high

  * [rcl_action] Bugfix: arithmetic error
  * Contributors: Jacob Perron

 -- Jacob Perron <jacob@openrobotics.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-crystal-rcl-action (0.6.1-1bionic) bionic; urgency=high

  * Added wait_for_action_server() for action clients (#349 <https://github.com/ros2/rcl/issues/349>)
  * Updated to adapt to action implicit changes (#353 <https://github.com/ros2/rcl/issues/353>)
  * Added action interaction tests (#352 <https://github.com/ros2/rcl/issues/352>)
  * Enabled test_action_communication to compile against available rmw. (#351 <https://github.com/ros2/rcl/issues/351>)
  * Changed UUID type in action msgs (#338 <https://github.com/ros2/rcl/issues/338>)
  * Added rcl_action_server_is_valid_except_context (#348 <https://github.com/ros2/rcl/issues/348>)
  * Updated to fini even if node context is invalid and reset error (#346 <https://github.com/ros2/rcl/issues/346>)
  * Added timer to action server to check expired goals + asan fixes (#343 <https://github.com/ros2/rcl/issues/343>)
  * Increased timeout for rcl_wait in action tests (#344 <https://github.com/ros2/rcl/issues/344>)
  * Refactored init to not be global (#336 <https://github.com/ros2/rcl/issues/336>)
  * Completes integration tests for action client/server (#331 <https://github.com/ros2/rcl/issues/331>)
  * Updated rcl_action_expire_goals() to output list of expired goals. (#342 <https://github.com/ros2/rcl/issues/342>)
  * Updated process_cancel_request to no longer change goal state (#341 <https://github.com/ros2/rcl/issues/341>)
  * Add action server implementation (#323 <https://github.com/ros2/rcl/issues/323>)
  * Contributors: Alexis Pojomovsky, Jacob Perron, Michel Hidalgo, Shane Loretz, William Woodall

 -- Jacob Perron <jacob@openrobotics.org>  Fri, 07 Dec 2018 08:00:00 -0000

ros-crystal-rcl-action (0.6.0-1bionic) bionic; urgency=high

  * Made rcl_action_get_*_name() functions check for empty action names. #329 <https://github.com/ros2/rcl/issues/329>
  * Implemented Action client #319 <https://github.com/ros2/rcl/issues/319>
  * Added function to check if goal can be transitioned to CANCELING (#325 <https://github.com/ros2/rcl/issues/325>)
  * Implement goal handle (#320 <https://github.com/ros2/rcl/issues/320>)
  * Update to use new error handling API from rcutils (#314 <https://github.com/ros2/rcl/issues/314>)
  * Add action services and topics name getters #317 <https://github.com/ros2/rcl/issues/317>
  * Implement init/fini functions for types (#312 <https://github.com/ros2/rcl/issues/312>)
  * Refactor goal state machine implementation and add unit tests (#311 <https://github.com/ros2/rcl/issues/311>)
  * Add missing visibilty control definitions (#315 <https://github.com/ros2/rcl/issues/315>)
  * Add rcl_action package and headers (#307 <https://github.com/ros2/rcl/issues/307>)
  * Contributors: Jacob Perron, Michel Hidalgo, William Woodall

 -- Jacob Perron <jacob@openrobotics.org>  Fri, 16 Nov 2018 08:00:00 -0000

=== debian/control ===
Source: ros-crystal-rcl-action
Section: misc
Priority: extra
Maintainer: Jacob Perron <jacob@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-crystal-action-msgs, ros-crystal-ament-cmake-gtest, ros-crystal-ament-cmake-ros, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-osrf-testing-tools-cpp, ros-crystal-rcl, ros-crystal-rcutils, ros-crystal-rmw, ros-crystal-rosidl-generator-c, ros-crystal-test-msgs, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-rcl-action
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-crystal-action-msgs, ros-crystal-rcl, ros-crystal-rcutils, ros-crystal-rmw, ros-crystal-rosidl-generator-c, ros-crystal-ros-workspace
Description: Package containing a C-based ROS action implementation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-rcl-action//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
